<html>
  <head>
    <meta charset="utf-8"/>
    <link rel="stylesheet" href="my.css">
    <script src="wasm_exec.js"></script>
  </head>
  <body>
    <h1>WASM Experiments</h1>

    <script> 

      function loadWasm(path) {
        const go = new Go()

        // Hack for use TinyGo
        // https://github.com/tinygo-org/tinygo/issues/1140
        go.importObject.gojs["syscall/js.finalizeRef"] = _ => 0 // 😉

        return new Promise((resolve, reject) => {
          WebAssembly.instantiateStreaming(fetch(path), go.importObject)
          .then(result => {
            go.run(result.instance)
            resolve(result.instance)
          })
          .catch(error => {
            reject(error)
          })
        })
      }

      /**
      * Promise
      * 
      * @param {boolean} generateError
      * @returns {Promise<string>}
      */
      function compute(generateError) {
        return new Promise((resolve, reject) => {

            setTimeout(_ => {
              if (generateError) { 
                reject(Error("😡 Fail")) 
              } else { 
                resolve("😃 Success") 
              }
            }, 3000)

        })
      }

      loadWasm("main.wasm").then(wasm => {
        console.log("😃 main.wasm is loaded")

      }).catch(error => {
        console.log("😡 ouch", error)
      }) 

    </script>
  </body>
</html>


